      Program anchorpt
c
c       This program will read a series of experimental absorbnace spectra
c       and calculate the linear absorption coefficient at the anchor 
c       points supplied by the user.
c
      include 'anchorpt.inc'
      parameter (ird=5, iout=6, itab=7)

      integer*2 xt,yt,npts,ier
      character*192 icomm
      character*80 comm
      character*12 name(maxf),nfile
      character*1 checkx(maxf,maxapt),checky(maxf,maxapt)
      real LAC, iaa
      dimension y(maxpts),eabs(maxf,maxapt), iaa(maxf,maxapt),x(maxapt),
     $ LAC(maxf,maxapt), rn(maxpts), path(maxf),avg(maxapt),std(maxapt),
     $ cl(maxapt)

      open(ird,file='anchorpt.asc',status='old')
      open(iout,file='anchorpt.out',status='unknown')
      open(itab,file='anchorpt.tab',status='unknown')
      write(itab,1020)
      
      read(ird,*)irunt
      
      do 10 irun=1,irunt
	write(*,*)' Calculating anchor points for run',irun
	read(ird,'(a80)')comm
	write(iout,'(a80)')comm
	read(ird,*)nfile
	call readsc(nfile,rn,npts,xspn,xepn,xt,yt,res,icomm,ier)
	delxn=(xspn-xepn)/(npts-1)
	if(npts.gt.maxpts)then
	  write(*,*)'Too many points in n file for run 1'
	  write(iout,*)'Too many points in n file for run 1'
	  go to 10
	end if
	
	read(ird,*)napts,numfile
	read(ird,*)(x(j),j=1,napts)
	do j=1,numfile
	  read(ird,*)name(j),path(j),icell
	  call readsc(name(j),y,npts,xsp,xep,xt,yt,res,icomm,ier)
	  if(npts.gt.maxpts)then
	    write(*,*)'Too many points in',name(j)
	    write(iout,*)'Too many points in',name(j)
	    go to 10
	end if

	  delx=(xsp-xep)/(npts-1.)
	  do k=1,napts
	    ipos=(xsp-x(k))/delx+1.5
	    checkx(j,k)=' '
	    checky(j,k)=' '
	    if(ipos.lt.1.or.ipos.gt.npts)then
	      eabs(j,k)=0.0
	      checky(j,k)='*'
	    else
	      eabs(j,k)=y(ipos)
	      if(abs(xsp-(ipos-1)*delx-x(k)).gt.0.1)checkx(j,k)='*'
	    end if
	  end do
	  
	  call appabs(x,iaa,rn,napts,path,icell,j,xspn,delxn)
	end do

	call stat(checky,eabs,iaa,lac,path,avg,std,cl,numfile,napts)

	do k=1,napts
	  write(iout,1005)x(k)
	  do j=1,numfile
	  if(checky(j,k).ne.'*')write(iout,1010)name(j),checkx(j,k),
     $     path(j),eabs(j,k),iaa(j,k),eabs(j,k)-iaa(j,k),lac(j,k)
	  end do
	  write(iout,1015)avg(k),std(k),cl(k)
	  write(itab,1025)x(k),avg(k),cl(k),0.1832339*cl(k)/x(k)
	end do
10    continue
      close(ird)
      close(iout)
      close(itab)
      stop

1005  format(/,2x,'Anchor point determination for ',f6.1,//,8x,'File',
     $ 7x,'Path',4x,'Exp Abs',2x,'Ideal App Abs',5x,'Abs',5x,'Abs/cm')
1010  format(4x,a,a,f7.2,2x,f7.5,6x,f7.5,6x,f7.5,1x,f8.4)
1015  format(18x,'Average :',f8.4,/,7x,'Standard Deviation :',f8.4,/,
     $ 4x,'95 % confidence limit :',f8.4,//)
1020  format(5x,'Nu /cm-1',5x,'K(nu) /cm-1',5x,'delta K(nu) /cm-1',
     $ 5x,'delta k(nu)')
1025  format(6x,f6.1,7x,f8.4,11x,f8.4,11x,1p,e7.1e1,0p)
      end

      subroutine stat(checky,eabs,iaa,lac,path,avg,std,cl,numfile,napts)
      include 'anchorpt.inc'

      real iaa,lac
      dimension eabs(maxf,maxapt), iaa(maxf,maxapt), lac(maxf,maxapt),
     $ path(maxf), avg(maxapt), std(maxapt), cl(maxapt),t(50)
      character*1 checky(maxf,maxapt)

      data t /0.0,12.706,4.303,3.182,2.776,2.571,2.447,2.365,2.306,
     #2.262,2.228,2.201,2.179,2.160,2.145,2.131,2.12,2.11,2.101,2.093,
     #2.086,2.08,2.074,2.069,2.064,2.06,2.056,2.052,2.048,2.045,2.042,
     #2.040,2.038,2.036,2.034,2.032,2.029,2.027,2.025,2.023,2.021,
     #2.02,2.019,2.018,2.017,2.016,2.015,2.014,2.013,2.012/
      
      do k=1,napts
	n=0
	sum=0
	do j=1,numfile
	  if(checky(j,k).ne.'*')then
	    n=n+1
	    lac(j,k)=1.e4*(eabs(j,k)-iaa(j,k))/path(j)
	    sum=sum+lac(j,k)
	  end if
	end do
	if(n.gt.1)then
	  avg(k)=sum/n
	  std(k)=0.0
	  cl(k)=0.0
	  do j=1,numfile
	    if(checky(j,k).ne.'*')std(k)=std(k)+(lac(j,k)-avg(k))**2
	  end do
	  std(k)=sqrt(std(k)/(n-1.))
	  cl(k)=std(k)*t(n)/sqrt(float(n))
	end if
      end do
      return
      end

      subroutine appabs(x,iaa,enr,napts,path,icell,nfile,xspn,delxn)
      include 'anchorpt.inc'

      real iaa
      DIMENSION RI(maxapt),RA(2),RB(2),X(maxapt),path(maxf),
     $ TA(2),TB(2),TC(2),TT(2),enr(maxpts),iaa(maxf,maxapt)
      REAL*8 AG(5),XG(5),DBLX,RIT2,XS(maxapt)
      COMPLEX CXA,CXB,CXCOS,CXE,CXEN,CXENC,CXE2,CX(2),CXR1(2),
     $ CXR2(2),CXT1(2),CXT2(2)

      DATA ND,NFY,AG,XG/2*5,0.236926885056189D0,0.478628670499366D0,
     $ 0.568888888888889D0,0.478628670499366D0,0.236926885056189D0,
     $ 0.906179845938664D0,0.538469310105683D0,0.0D0,
     $ -0.538469310105683D0,-0.906179845938664D0/

      DM0=0.0001*path(nfile)
      DM1=0.0
      FPDM0=12.56637*DM0
      FY1=0.0174533*5.5
      
      DO 25 I=1,napts
	XS(I)=X(I)*X(I)
   25 CONTINUE
	DO 35 I=1,napts
	  DBLX=DBLE(X(I))
	  RI(I)=RIT2(DBLX,ICELL)
   35   CONTINUE

C
C     START OF THE WAVENUMBER LOOP
C
      DO 80 I=1,napts
	W=X(I)
	ipos=(xspn-x(i))/delxn +1.5
	en2=enr(ipos)
	POL=0.5
	POLP=1.0-POL
	EN1=RI(I)
	EN1SQ=EN1*EN1
	REN=1.0/EN1SQ
	T=0.0
C
C       START OF THE ANGLE LOOP
C
	DO 70 IFI=1,NFY
	  FI0=0.5*FY1*(1.0+XG(IFI))
	  CF0=COS(FI0)
	  SF0=SIN(FI0)
	  CF1=SQRT(1.0-SF0*SF0*REN)
C
C         R AND T AT A AND C BOUNDARIES
C
	  ENC1=EN1*CF1
	  B=CF0+ENC1
	  B=1/(B*B)
	  A1=4.0*CF0**2
	  TA(1)=A1*B
	  A2=4.0*ENC1*ENC1
	  TC(1)=A2*B
	  A3=CF0-ENC1
	  RA(1)=A3*A3*B
	  B=CF1+EN1*CF0
	  B=1/(B*B)
	  TA(2)=A1*B
	  TC(2)=A2*B
	  A3=EN1*CF0-CF1
	  RA(2)=A3*A3*B
C
C         START OF BASELINE-SAMPLE LOOP
C         CALCULATION OF THE COMPLEX FRESNEL COEFFICIENTS
C
	  CXEN=CMPLX(EN2,0.0)
	  CXA=SF0/CXEN
	  CXCOS=CSQRT(1.0-CXA*CXA)
	  CXENC=CXEN*CXCOS
C         1 DENOTES THE S COMPONENT, 2 THE P COMPONENT
	  CX(1)= ENC1+CXENC
	  CX(2)= EN1*CXCOS+CXEN*CF1
	  CXR1(1)=(ENC1-CXENC)/CX(1)
	  CXR1(2)=(CXEN*CF1-EN1*CXCOS)/CX(2)
	  DO 55 IP=1,2
	    CXT1(IP)=2.0*ENC1/CX(IP)
	    CXT2(IP)=2.0*CXENC/CX(IP)
	    CXR2(IP)=-CXR1(IP)
   55     CONTINUE
	  TD=0.0
C
C         START OF THE PATH LENGTH LOOP
C
	  DO 65 ID=1,ND
	    D=DM0+DM1*XG(ID)
	    CXA=CMPLX(0.0,1.0)*6.283184*D*W*CXENC
C           CXA IS I*DELTA
C           R AND T AT B BOUNDARY ( THIN FILM )
	    CXE=CEXP(CXA)
	    CXE2=CXE*CXE
	    DO 60 IP=1,2
	      CXA=CXR2(IP)*CXE2
	      CXB=1.0/(1.0+CXR1(IP)*CXA)
	      CXA=(CXR1(IP)+CXA)*CXB
	      RB(IP)=DREAL(CXA*CONJG(CXA))
	      CXA=CXT1(IP)*CXT2(IP)*CXE*CXB
	      TB(IP)=DREAL(CXA*CONJG(CXA))
C
C             TOTAL T
C
	      RAIP=RA(IP)
	      RBIP=RB(IP)
	      W1=RAIP*RBIP
	      W2=1.0/(1.0-W1)
	      RBA=(RAIP+RBIP-2.0D0*W1)*W2
	      W1=RBA*RAIP
	      W3=1.0/(1.0-W1)
	      TT(IP)=TA(IP)*TB(IP)*TC(IP)*W2*W3
   60       CONTINUE
	    TD=TD+AG(ID)*(POL*TT(1)+POLP*TT(2))
   65     CONTINUE
C         END OF THICKNESS LOOP
C
	  T=T+AG(IFI)*TD
   70   CONTINUE
C
C       END OF ANGLE AND BASELINE-SAMPLE LOOPS
	iaa(nfile,I)=0.60205999-ALOG10(T)
   80 CONTINUE
C
C     END OF WAVENUMBER LOOP
C
C
      return
      END


	      
