CCCCCCC PROGRAM LZKKTB CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                 C
C       IT USES EITHER KKTM OR KKT AS TRANSFORM ROUTINE.          C
C                                                                 C
C       IT READS DATA FROM FILE 'LZKKT.ASC', WHICH HAS THE        C
C       FORMAT AS FOLLOWING:                                      C
C                   KNINDX, RNINF, XIN, NREST, RLAST              C
C                   NAME1                                         C
C                 [ NAME2 ]                                       C
C                   NAME                                          C
C       THIS PART CAN BE REPEATED TO DO TRANSFORM ON MORE THAN 1  C
C       k SPECTRUM WITH SINGLE RUN  --  GOOD FOR BATCH JOB.       C
C                                                                 C
C       PARAMETERS:                                               C
C           KNINDX --  0 = k TO n TRANSFORM                       C
C                      NON-ZERO INTEGER = n TO k TRANSFORM        C
C           RNINF  --  N INFINITY                                 C
C           XIN    --  WAVENUMBER AT THE CRITICAL POINT.          C
C                      BETWEEN XS (HIGHEST WAVE#) AND XIN,PROGRAM C
C                      CALCULATES n OR k EVERY 100 POINTS.        C
C                      XIN=0 -- NO APPROXIMATION                  C
C           NREST & RLAST ARE RELATED TO THE CORRECTION DESCRIBED C
C                      IN THE HILBERT TRANSFORM INSTRUCTIONS.     C
C           NAME1  --  INPUT k OR n FILENAME                      C
C           NAME2  --  OUTPUT ENLARGED k OR n FILENAME            C
C           NAME   --  OUTPUT n OR k FILENAME                     C
C                                                                 C
C       OUTPUT: BESIDES n (OR k) SPECTRA, PROGRAM GIVES OUT A     C
C               JOB REPORT IN FILE 'LZKKT.OUT' FOR EACH RUN.      C
C                                                                 C
C       NOTE: IF XIN IS 0.0 OR # OF DATA POINTS BETWEEN XS AND    C
C             XIN IS LESS THAN 200, PROGRAM CALLS KKT WHICH DOES  C
C             NOT USE ANY APROXIMATION.                           C
C                                                                 C
CCCCCCC WRITTEN BY S.L.ZHANG, AUGUST/1990 CCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCC            SLZ - PRIL 16, 1991, FINALIZED ON JULY 8, 1991
CCCCCCC                  AUG 22,1991, BUILT n TO k TRANSFORM
CCCCCCC                  Nov. 12, 1993, based on LZKKTC, enlarged array
CCCCCCC      sizes from 9336 to 18673
CCCCCCC      and the input and output files changed to
CCCCCCC      LZKKTB.asc and LZKKTB.out, respectively.

	INTEGER*1 XT,YT
	INTEGER*2 NFIX,NP2
	CHARACTER*12 NAME,NAME1,NAME2
	CHARACTER*192 COMM
	DIMENSION RR(18673),RI(18673),X2(18673),XK(18673)
	PARAMETER (IR=5,IW=6)
C       18673 IS THE # OF PTS FOR A SPECTRUM IN THE REGION
C       9000-0 CM-1 WITH SPACING 0.964233/2 CM-1

	OPEN(IR,FILE='LZKKTb.ASC',STATUS='OLD')
	OPEN(IW,FILE='LZKKTb.OUT',STATUS='UNKNOWN')

	NJOB=0
909     NJOB=NJOB+1
	READ(IR,*,END=993) KNINDX,RNINF, XIN, NREST, RLAST
	IF (NREST.NE.0) THEN
	    READ(IR,'(A12)') NAME1,NAME2,NAME
	ELSE
	    READ(IR,'(A12)') NAME1,NAME
	ENDIF
	WRITE(IW,994) NJOB

C       SET TIMER FOR JOB REPORT
	CALL GETTIM(IHR,IMIN,ISEC,I100TH)
	WRITE(IW,1011)IHR,IMIN,ISEC

	CALL READSC(NAME1,RR,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
	WRITE(IW,995)NAME1,NAME2,NAME,RNINF,XS,XE,NFIX,XIN,NREST,RLAST
	WRITE(*,*)' job',NJOB
	WRITE(*,*)' input    filename: ',NAME1,'   NP=',NFIX
	IF (NREST.NE.0) WRITE(*,*)' appended filename: ',NAME2
	WRITE(*,*)' output   filename: ',NAME
	IF (NFIX.GT.18673) THEN
	    WRITE(IW,996)
	    GOTO 909
	ELSEIF (KNINDX.NE.0) THEN
	    DO 2 I=1,NFIX
2           RR(I)=RR(I)-RNINF
	    RLAST=RR(NFIX)
	ENDIF

5       H=(XE-XS)/(Nfix-1)
C       DEAL WITH THE APPROXIMATION
C       MAKE SURE THAT NL IS AN EVEN NUMBER (PROGRAMMING EASILIER)
	IF (XIN.EQ.0.0) GOTO 8
	NL=IABS((XIN-XS)/H)
	NL=NL/2
	NL=NL*2
8       NP=NFIX
C       ENLARGE THE INPUT AND SAVE THE ENLARGED k SPECTRUM ONTO DISK
	IF (NREST.EQ.0) GOTO 20
	NP=NFIX+NREST
	IF (NP.GT.18673) NP=18673
	NREST=NP-NFIX
	XE1=XE+H*NREST
	IF (XE1.GT.0.) GOTO 10
	NREST=-XE/H
	NP=NFIX+NREST
	XE1=XE+H*NREST
10      RNUM=RR(NFIX-1)
	IF (RNUM.GT.RR(NFIX)) RNUM=RR(NFIX)-(RNUM-RR(NFIX))
	DO 18 I=NFIX+1,NP
18      RR(I)=RNUM-(I-NFIX-1)*(RNUM-RLAST)/FLOAT(NREST)
	NP2=NP
	CALL WRITESC(NAME2,RR,NP2,XS,XE1,XT,YT,RESO,COMM,IER)
C       PAUSE ' PAUSE -- AFTER WRITING THE ENLARGED k SPECTRUM'

20      NPTS=NFIX
	IF (XIN.EQ.0.0.OR.NL.LE.200) THEN
	    CALL KKT(KNINDX,RNINF,H,NPTS,NP,XS,RR,RI,X2,XK)
	ELSE
	    CALL KKTM(KNINDX,RNINF,NL,H,NPTS,NP,XS,RR,RI,X2,XK)
	ENDIF
	CALL WRITESC(NAME,RI,NFIX,XS,XE,XT,YT,RESO,COMM,IER)

C       SET TIMER FOR JOB REPORT
	CALL GETTIM(IHR,IMIN,ISEC,I100TH)
	WRITE(IW,1012)IHR,IMIN,ISEC
	GOTO 909
993     WRITE (IW,*)'THE END OF THE BATCH JOB'
	CLOSE(IW)
	CLOSE(IR)
994     FORMAT(//,' BATCH JOB ',I3,/)
995     FORMAT(
     1  ' INPUT FILENAME: ',A,/,' EXTENDED FILENAME: ',A,/,
     2  ' OUTPUT SPC FILENAME: ',A,/,' n INFINITY: ',F10.6,/,
     3  ' STARTING WAVENUMBER:',F8.2,'  ENDING WAVENUMBER: ',
     4  F8.2,'  WITH ',I5,' PTS',/,
     5  ' CRITICAL POINT AT ',F8.2,/,
     7  ' EXTENDED ',I4,' PTS TO LOW END WITH VALUE OF',F8.4
     8  , ' AT THE LAST POINT')
996     FORMAT(/,' INPUT DATA FILE CONTAINS MORE THAN 18673 PTS'
     1  ,', PROGRAM STOPS THIS CALCULATION')
1011    FORMAT(/,1X,'BEFORE KKT, TIME IS',I3,':',I2,':',I2)
1012    FORMAT(  1X,'AFTER  KKT, TIME IS',I3,':',I2,':',I2)
	END

CCCCC KKT and KKTM (SUBROUTINES)
C     --- USED IN LZKKT, AND KKTSUB
C     --- THESE ROUTINES CALCULATE THE N SPECTRUM FROM THE K SPECTRUM.
C         IT USES THE STANDARD KRAMERS-KRONIG ALGORITHM.
C
C         KKT  --  FULL KK TRANSFORMATION WITHOUT APPROXIMATION.
C                  INTEGRATION OVER THE WHOLE RANGE OF SPECTRA
C         KKTM --  APPROXIMATIONS USED

      SUBROUTINE KKTM(KNINDX,RNINF,NL,H,NFIX,N,XS,RK,RN,X2,X)
C     -- SAME AS KKT EXCEPT USING APPROXIMATIONS
C      REAL*8 HPI,SLOPE,X(18673),X2(18673)
      DIMENSION RK(*),RN(*),X(*),X2(*)

      CALL GETTIM(IH,IM,IS,IS100)
      WRITE(*,923) IH,IM,IS
      HPI=1.2732395447D0*ABS(H)
      XG=XS
      DO 10 I=1,N
      X(I)=XG
      X2(I)=XG*XG
10    XG=XG+H
      IF (KNINDX.EQ.0) THEN
	    DO 20 I=1,N
20          RK(I)=RK(I)*X(I)
      ENDIF

C     FIRST PART OF THE WHOLE RANGE
      CALL KSUM(2,NL,100,1,N,X2,RK,RN,HPI)

C     SECOND PART OF THE WHOLE RANGE
      N2=NL+200
      CALL KSUM(NL,N2,2,1,N,X2,RK,RN,HPI)
      N1=NL+1
      CALL KSUM(N1,N2,2,2,N,X2,RK,RN,HPI)

C     THIRD PART OF THE WHOLE RANGE
      N1=N2+1
      N2=NFIX
      IF (NFIX.EQ.N) N2=N2-1
      CALL KSUM(N1,N2,2,NL,N,X2,RK,RN,HPI)
      N1=N1+1
      N4=NL-1
      CALL KSUM(N1,N2,2,N4,N,X2,RK,RN,HPI)

C     INTERPOLATING FOR 1ST PART
      NI=(NL-2)/100
      DO 410 I=1,NI
      I2=2+I*100
      I1=I2-100
      SLOPE=RN(I2)-RN(I1)
      I21=I2-1
      I11=I1+1
      DO 410 J=I11,I21
410   RN(J)=RN(I1)+SLOPE*(J-I1)/100.
      I1=2+NI*100
      SLOPE=RN(NL)-RN(I1)
      I21=NL-1
      I11=I1+1
      DO 420 J=I11,I21
420   RN(J)=RN(I1)+SLOPE*(J-I1)/(NL-I1)

      CALL GETTIM(IH,IM,IS,IS100)
      WRITE(*,924) IH,IM,IS
923   FORMAT('  BEFORE KK, TIME IS ',I2,':',I2,':',I2,
     1     /,'  DOING TRANSFORM...KKTM...PLEASE WAIT')
924   FORMAT('  AFTER  KK, TIME IS ',I2,':',I2,':',I2)
      RN(1)=RN(2)
      IF (NFIX.EQ.N) RN(NFIX)=RN(NFIX-1)
      IF (KNINDX.EQ.0) THEN
	    DO 25 I=1,NFIX
25          RN(I)=RN(I)+RNINF
      ELSE
	    DO 30 I=1,NFIX
30          RN(I)=-RN(I)*X(I)
      ENDIF
      RETURN
      END

      SUBROUTINE KKT(KNINDX,RNINF,H,NFIX,N,XS,RK,RN,X2,X)
C      REAL*8 HPI,X,X2(18673),X(18673)
      DIMENSION RK(*),RN(*),X2(*),X(*)

      CALL GETTIM(IH,IM,IS,IS100)
      WRITE(*,923) IH,IM,IS
      HPI=1.2732395447D0*ABS(H)
      XG=XS
      DO 10 I=1,N
      X(I)=XG
      X2(I)=XG*XG
10    XG=XG+H
      IF (KNINDX.EQ.0) THEN
	    DO 20 I=1,N
20          RK(I)=RK(I)*X(I)
      ENDIF

      N2=NFIX
      IF (NFIX.EQ.N) N2=N2-1
      CALL KSUM(2,N2,2,1,N,X2,RK,RN,HPI)
      CALL KSUM(3,N2,2,2,N,X2,RK,RN,HPI)

      CALL GETTIM(IH,IM,IS,IS100)
      WRITE(*,924) IH,IM,IS
923   FORMAT('  BEFORE KK, TIME IS ',I2,':',I2,':',I2,
     1     /,'  DOING TRANSFORM...KKT...PLEASE WAIT')
924   FORMAT('  AFTER  KK, TIME IS ',I2,':',I2,':',I2)
      IF (NFIX.EQ.N) RN(NFIX)=RN(NFIX-1)
      RN(1)=RN(2)
      IF (KNINDX.EQ.0) THEN
	    DO 25 I=1,NFIX
25          RN(I)=RN(I)+RNINF
      ELSE
	    DO 30 I=1,NFIX
30          RN(I)=-RN(I)*X(I)
      ENDIF
      RETURN
      END

      SUBROUTINE KSUM(N1,N2,N3,N4,N5,X2,RK,RN,HPI)
C      REAL  S,HPI,X2(*),RK(*)
      DIMENSION RN(*),X2(*),RK(*)

      DO 130 I=N1,N2,N3
      S=0.D0
      DO 125 J=N4,N5,2
125   S=S+RK(J)/(X2(J)-X2(I))
130   RN(I)=HPI*S
      RETURN
      END
