C
C     ******************************************************************
C
C     SUBROUTINE POLCO2 --- THIS COMPUTES THE POLARIZATION
C	       DISCRIMINATION COEFFICIENTS.
C
      SUBROUTINE POLCO2 (XNU,PNU,PC,NPC,NP,BREAK1,BREAK2,POLS)
C
      DIMENSION XNU(1),PNU(1),PC(1),POLS(1)
      IF(NPC.EQ.0)THEN
	DO 10 I=1,NP
	  POLS(I)=0.5
   10	CONTINUE
      ELSE
C	LOCALIZATION OF BREAK1 AND BREAK2 IN THE PC ARRAY
C
	J=NPC
	J1=NPC
	J2=NPC
	DO WHILE (BREAK2.GT.PNU(I))
	  J=J-1
	  J2=J
	END DO
	DO WHILE (BREAK1.GT.PNU(J))
	  J=J-1
	  J1=J
	END DO
	DO 100 I=1,NP
	  W=XNU(I)
C
C	  POLARIZATION COEFFICIENTS INTERPOLATION SECTION
C
	  J=1
	  JLIM=J1-1
	  IF (W.LT.BREAK2)THEN
	    J=J2+1
	    JLIM=NPC-1
	  ELSE IF(W.LT.BREAK1)THEN
	    J=J1+1
	    JLIM=J2-1
	  END IF
   80	  IF (PNU(J+1).LE.W) GO TO 90
	  J=J+1
	  IF (J.LE.JLIM) GO TO 80
	  J=J-1
   90	  DP=(PC(J)-PC(J+1))/(PNU(J)-PNU(J+1))
	  DNU=PNU(J)-W
	  POLS(I)=(PC(J)-DP*DNU)/(1.0+PC(J)-DP*DNU)
  100	CONTINUE
      END IF
      RETURN
      END
