C
C     ******************************************************************
C
C     FUNCTION RIT2 (REFRACTION INTERPOLATION) --- THIS IS GENERATED
C	   FROM THE ALGORITHMS OF PROGRAM XXXVIII (PC-202) BASED ON
C	   DISPERSION DATA FOR THE COMMON INFRARED OPTICAL MATERIALS
C	   TAKEN FROM THE THE LITERATURE.
C
      DOUBLE PRECISION FUNCTION RIT2(WN,ICELL)
      IMPLICIT REAL*8(A-H,O-Z)
C
      WLSQ=(10000.D0/WN)**2
      GO TO (1,2,3,4,5,6,7),ICELL
C     GERMANIUM, ICELL=1
    1 AL=1.0D0/(WLSQ-0.028D0)
      RIT2=3.99931D0+0.391707D0*AL+0.163492D0*AL*AL-0.6D-5*WLSQ+0.53D-7*
     $WLSQ*WLSQ
      RETURN
C     LITHIUM FLUORIDE, ICELL=2
    2 AL=1.0D0/(WLSQ-0.028D0)
      RIT2=1.38761D0+0.1796D-2*AL-0.41D-4*AL*AL-0.23045D-2*WLSQ-
     $0.557D-5*WLSQ*WLSQ
      RETURN
C     BARIUM FLUORIDE, ICELL=3
    3 RIT2=DSQRT(1.D0+WLSQ*(0.643356D0/(WLSQ-0.33396D-2)+0.506762D0/
     $(WLSQ-0.1203D-1)+3.8261D0/(WLSQ-2151.7D0)))
      RETURN
C     CALCIUM FLUORIDE, ICELL=4
    4 RIT2=DSQRT(1.0D0+WLSQ*(0.5675888D0/(WLSQ-0.252643D-2)+0.4710914D+0
     $/(WLSQ-0.1007833D-1)+3.8484723D0/(WLSQ-1200.556D0)))
      RETURN
C     CESIUM IODIDE, ICELL=5
    5 RIT2=DSQRT(1.D0+WLSQ*(0.34617251D0/(WLSQ-0.52701D-3)+1.0080886D0/
     $(WLSQ-0.2149156D-1)+0.285518D0/(WLSQ-0.32761D-1)+0.39743178D0/
     $(WLSQ-0.44944D-1)+3.3605359D0/(WLSQ-25921.D0)))
      RETURN
C     POTASSIUM BROMIDE, ICELL=6
    6 RIT2=DSQRT(2.361323D0-0.311497D-3*WLSQ-0.58613D-7*WLSQ**2+0.7676D-
     $2/WLSQ+0.156569D-1/(WLSQ-0.324D-1))
      RETURN
C     SODIUM CHLORIDE, ICELL=7
    7 RIT2=DSQRT(2.330165D0-0.9285837D-3*WLSQ-0.286086D-6*WLSQ**2+
     $0.1278635D-1/(WLSQ-0.1484985D-1)+0.5343924D-2/(WLSQ-0.25474707D-1
     $))
      RETURN
      END
